SystemOrganization addCategory: #GODBases!

Object subclass: #GDBConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODBases'!

!GDBConnection class methodsFor: 'as yet unclassified' stamp: 'lacm 11/1/2014 01:16'!
connection
      GDBMagmaClient session.      
    
	GDBMagmaClient commit: [
		GDBMagmaClient root at: 'gdbdata'
							  put: OrderedCollection new.
		].
	
	GDBMagmaClient root.
! !

!GDBConnection class methodsFor: 'as yet unclassified' stamp: 'lacm 11/1/2014 00:37'!
database
      "we create a new key for the root dictionary"
	^ GDBMagmaClient root at: 'gdbdata'.! !

Object subclass: #GDBController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODBases'!

!GDBController commentStamp: 'lacm 11/1/2014 00:03' prior: 0!
A GDBController is a class that permits differents transactions in our Magma database.
!

!GDBController class methodsFor: 'adding' stamp: 'lacm 11/1/2014 01:01'!
add: anGODData
"This method permits to insert an GODData object in the datase"
      GDBMagmaClient commit: [GDBConnection database add:  anGODData ].
	GDBConnection database explore
	! !

!GDBController class methodsFor: 'as yet unclassified' stamp: 'lacm 11/1/2014 01:00'!
release
	GDBMagmaClient release.! !

!GDBController class methodsFor: 'removing' stamp: 'lacm 11/1/2014 01:01'!
remove: anGODData
"This method permits to delete an GODData object in the datase"
       GDBMagmaClient commit: [GDBConnection database remove: anGODData].
       GDBConnection database explore
! !

!GDBController class methodsFor: 'as yet unclassified' stamp: 'lacm 11/1/2014 00:54'!
uniqueInstance
      GDBConnection connection.
! !

!GDBController methodsFor: 'as yet unclassified' stamp: 'lacm 11/1/2014 01:13'!
printOn: aStream	
     super initialize.
"this method is not inplemented yet"! !

Object subclass: #GDBMagmaClient
	instanceVariableNames: 'session'
	classVariableNames: 'DefaultConnection'
	poolDictionaries: ''
	category: 'GODBases'!

!GDBMagmaClient commentStamp: 'lacm 11/1/2014 01:10' prior: 0!
Before following these instructions, first set up your server in a separate running image by following the instructions in the class comment of GDBMagmaServer.

After you have the server running, switch back to this image and do the following.

First, run the following:	
	
	GDBController uniqueInstance.
	
Then, you may add data in the GODData run the following:

  	GDBController add:  myGODData.

where, myGODData is an GODData object.

Then, you may remove an GODData in the Magma database run the following:

	GDBController remove:  myGODData.

Finally, to release the client run the following:

	GDBController release.!

!GDBMagmaClient class methodsFor: 'connection' stamp: 'lacm 9/28/2014 20:53'!
commit: aBlock
	self default session commit: aBlock! !

!GDBMagmaClient class methodsFor: 'connection' stamp: 'lacm 10/15/2014 12:19'!
default
	^ DefaultConnection ifNil: [
			DefaultConnection := self new connect; 
			yourself
			].! !

!GDBMagmaClient class methodsFor: 'connection' stamp: 'lacm 10/15/2014 12:21'!
release
	(DefaultConnection isNil)
	ifFalse:[
			DefaultConnection session disconnectAndClose.
			DefaultConnection := nil.
		]! !

!GDBMagmaClient class methodsFor: 'connection' stamp: 'lacm 11/1/2014 01:24'!
root
"This method retrieves the connection for access to the session, and then access to the root method of Magma "
	^ self session root! !

!GDBMagmaClient class methodsFor: 'connection' stamp: 'lacm 11/1/2014 01:24'!
session
	^ self default session! !

!GDBMagmaClient methodsFor: 'as yet unclassified' stamp: 'lacm 9/28/2014 20:50'!
connect
	session := (MagmaRemoteLocation
					host: 'localhost'
					port: 51001) newSession.
	session connectAs: 'lucy'.! !

!GDBMagmaClient methodsFor: 'private' stamp: 'lacm 9/28/2014 20:51'!
session
	^ session! !

!GDBMagmaClient methodsFor: 'private' stamp: 'lacm 10/15/2014 12:23'!
session: anObject
	session := anObject! !

Object subclass: #GDBMagmaServer
	instanceVariableNames: 'gdbServer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODBases'!

!GDBMagmaServer commentStamp: 'lacm 10/19/2014 15:44' prior: 0!
To create the repository, in a workspace, run only once:
	
	GDBMagmaServer new createGDBRepository

hence, to connect the server, run only once the following line:  

	GDBMagmaServer new startGDBServer

then, save it as an image server. To close the server, close that image saved, and when you open it again, the server will already be running.!

!GDBMagmaServer methodsFor: 'repository' stamp: 'lacm 10/15/2014 12:11'!
createGDBRepository
	MagmaRepositoryController
		create: self repositoryName
		root:  Dictionary new.! !

!GDBMagmaServer methodsFor: 'private' stamp: 'lacm 10/15/2014 12:09'!
port
	^ 51001! !

!GDBMagmaServer methodsFor: 'private' stamp: 'lacm 10/31/2014 22:44'!
repositoryName
	^ 'gdbMagmaExampleY'! !

!GDBMagmaServer methodsFor: 'server' stamp: 'lacm 10/15/2014 12:25'!
startGDBServer
	gdbServer := MagmaServerConsole new
		open: self repositoryName;
		processOn: self port;
		yourself.
	self inspect! !

!GDBMagmaServer methodsFor: 'server' stamp: 'lacm 10/15/2014 12:14'!
stopGDBServer
	gdbServer shutdown! !
